#ifndef SYSTEM_H
#define SYSTEM_H



//PIC16LF1559 example
#define I2C_CLR_SDA {TRISB4=0;}
#define I2C_SET_SDA {TRISB4=1;}
#define IS_SDA_PIN_HIGH (RB4)
#define I2C_SCL_PIN_INPUT {ANSB6=0; TRISB6=1; LATB6=0;}
#define I2C_CLR_SCL {TRISB6=0;}
#define I2C_SET_SCL {TRISB6=1;}
#define IS_SCL_PIN_HIGH (RB6)

#define SPI_CLK_HIGH {LATB6=1;}
#define SPI_CLK_LOW {LATB6=0;}
#define SPI_MOSI_HIGH {LATC7=1;}
#define SPI_MOSI_LOW {LATC7=0;}
#define IS_SPI_MISO_HIGH (RB4)
#define SPI_CS_LOW  {LATC6=0;}
#define SPI_CS_HIGH {LATC6=1;}

//Delay needs to be at least 4uS
//Using 16Mhz internal oscillator, 4 clocks per instruction, 4instructions per uS, so 16 NOPs needed
#define nop {asm("NOP");}
#define I2C_DELAY {nop;nop;nop;nop;nop;nop;nop;nop;nop;nop;nop;nop;nop;nop;nop;nop;}

#define I2C_CLEAR_INT {PIR1bits.SSP1IF = 0;}
#define IS_I2C_INT (PIR1bits.SSP1IF)

//SPI clock can be 3Mhz max
//With a 16Mhz internal oscialltor, 4 instructions per micro second
#define SPI_DELAY {nop;}

void sys_delay_ms(U16 x);
U8 sys_i2c_init(void);
U8 sys_i2c_write(U8 dev_addr, U8 *buf, U8 len);
U8 sys_i2c_read(U8 dev_addr, U8 *buf, U8 len);
U8 sys_uart_init(void);
U8 sys_uart_tx_byte(U8 x);
U8 sys_uart_rx_byte(U8 *data);
U8 sys_spi_init(void);
U8 sys_spi_byte(U8 tx, U8 *rx);
void sys_spi_cs(U8 x);
void sys_i2c_dbg_io(void);

	
#endif//SYSTEM_H
